"use strict";
this.name = "Cabal_Common_MissionHandling";
this.author = "Svengali";
this.copyright = "(C)2010-2013, License:CC-by";
this.description = "Coordinate mission offerings based on system descriptions.";
this.version = "1.7";

this.mPool = [];
this.startUp = function()
{
	delete this.startUp;
	this.helper = new worldScripts.Cabal_Common_Functions.Cabal_Common();
	this.binSearch = new worldScripts.Cabal_Common_Functions.Cabal_Common_BinSearch();
	this.checked = false;
	this.runningMission = false;
	this.logging = false;
};
this.prepare = function()
{
	var s = [],r = this.mPool.length;
	if(r){
		var merged = [],pos=0;
		for(var m=0;m<r;m++){
			s = this.mPool[m];
			if(s.length!==2 || !s[1].name || typeof(s[1].name)!=='string' || !s[1].func || typeof(s[1].func)!=='string') continue;
			if(s[1].hasOwnProperty("incOXP")){
				var temp = s[1].incOXP;
				for(var i=0;i<temp.length;i++){
					if(worldScripts[temp[i]]!=='undefined'){
						log(this.name,"Dropping token "+s[0]+" : "+s[1].name+"."+s[1].func+" because of incompatibility with "+temp[i]+".");
						continue;
					}
				}
			}
			if(!s[1].hasOwnProperty("mutalEx") || typeof(s[1].mutalEx)!=='number') s[1].mutalEx = 0;
			pos = merged.indexOf(s[0]);
			if(pos===-1) merged.push(s[0],{0:s[1]});
			else {
				var q = merged[pos+1];
				for(var p=1;p<10;p++){
					if(q.hasOwnProperty(p)) continue;
					q[p] = s[1];
					break;
				}
			}
		}
		r = merged.length;
		for(var i=0;i<r;i+=2){
			this.binSearch.add(merged[i],merged[i+1]);
		}
		if(this.logging) log(this.name,"merged: "+JSON.stringify(merged));
	} else {
		delete this.performCheck;
		delete this.shipWillExitWitchspace;
		delete this.shipWillLaunchFromStation;
		this.checked = true;
	}
	delete this.alertConditionChanged;
	delete this.guiScreenChanged;
	delete this.prepare;
	return;
};
this.performCheck = function(early)
{
	this.checked = true;
	if(this.runningMission) return;
	var test = system.description,prop;
	var pRand = this.helper.pseudoRand(system.ID,true);
	var rest = test.replace(/[^a-zA-Z]/g,' ');
	rest = rest.split(" ");
	rest = this.helper.arrUnique(rest);
	var fflag = false, l = rest.length, muteGroup = [];
	for(var s=0;s<l;s++){
		fflag = this.binSearch.contains(rest[s]);
		if(fflag && typeof(fflag)!=='false'){
			for(prop in fflag){
				var c = fflag[prop];
				if((early && !c.early) || (!early && c.early)) continue;
				if(muteGroup.indexOf(c.mutalEx)!==-1) continue;
				if(c.chance && Math.random()>c.chance) continue;
				if(c.gal && c.gal.indexOf(galaxyNumber)===-1) continue;
				if(c.ID && c.ID.indexOf(system.ID)===-1) continue;
				if(c.gov && c.gov.indexOf(system.government)===-1) continue;
				if(c.seeds && c.seeds.indexOf(pRand)===-1) continue;
				if(c.exToken && rest.indexOf(c.exToken)!==-1) continue;
				if(this.logging) log(this.name,"check: "+c.name+" - muteGroup: "+c.mutalEx+" rest[s]:"+rest[s]);
				if(worldScripts[c.name]){
					var act = false;
					if(c.func && worldScripts[c.name][c.func]) act = worldScripts[c.name][c.func](rest[s]);
					if(act){
						muteGroup.push(c.mutalEx);
						this.runningMission = true;
					}
				}
			}
		}
	}
	return;
};
this.alertConditionChanged = this.guiScreenChanged = function()
{
	if(this.prepare) this.prepare();
	if(!this.checked && this.performCheck) this.performCheck();
};
this.shipWillExitWitchspace = function()
{
	this.runningMission = false;
	if(this.performCheck) this.performCheck(1);
};
this.shipExitedWitchspace = function()
{
	if(this.performCheck) this.performCheck();
};
this.shipWillLaunchFromStation = function()
{
	if(this.prepare) this.prepare();
	if(!this.checked && this.performCheck) this.performCheck(1);
};
this.shipLaunchedFromStation = function()
{
	if(!this.checked && this.performCheck) this.performCheck();
};
