"use strict";
this.name = "Cabal_Common_Music";
this.author = "Svengali";
this.copyright = "(C)2010-2013, License:CC-by";
this.description = "Music helper for missions";
this.version = "1.7";

this.startUp = function()
{
	delete this.startUp;
	this.helper = new worldScripts.Cabal_Common_Functions.Cabal_Common();
	this.mediaFade = new SoundSource();
	this.mediaFade.sound = "[cabal_common_music_fade1]";
	this.mediaQueue = null;
	this.mediaPool = {
		allListed:[],
		aegis:{enter:[],exit:[]},
		alert:{red:[],yellow:[],green:[]},
		destroyed:{ent:[]},
		exitWS:{inter:[],goneNova:[],doNova:[],standard:[],any:[]},
		launch:{ent:[],inter:[],goneNova:[],doNova:[],main:[],any:[]},
		planet:{ent:[],enterMain:[],enterSun:[],exitMain:[],exitSun:[]},
		scooped:{ent:[],fuel:[]},
		track:{byName:[],byRole:[]}
	};
	this.currentFile = null;
	this.currentTrack = null;
	this.requestHandlerSet = [];
	this.blockAlert = 1;
	this.blockPlanet = 1;
	this.blockFuel = 1;
	var handler = Object.keys(this.mediaPool);
	handler.shift();
	for(var i=0;i<handler.length;i++){
		var c = Object.keys(this.mediaPool[handler[i]]);
		c.unshift(handler[i]);
		this.requestHandlerSet.push(c);
	}
};
// Register events
this.addMedia = function(obj)
{
	if(this.startUp) this.startUp();
	if(!obj || !Object.isExtensible(obj) || !obj.who || !worldScripts[obj.who] || !obj.hasOwnProperty("start")) return(false);
	var pid = -1;
	if(this.mediaPool.allListed.length){
		for(var i=0;i<this.mediaPool.allListed.length;i++){
			if(obj.who===this.mediaPool.allListed[i][0]){
				pid = i;
				break;
			}
		}
	}
	if(pid===-1){
		pid = this.mediaPool.allListed.length;
		this.mediaPool.allListed.push([obj.who,obj.start]);
	}
	for(var handler in this.mediaPool){
		if(handler==="allListed") continue;
		if(obj.hasOwnProperty(handler)){
			for(var what in this.mediaPool[handler]){
				if(obj[handler].hasOwnProperty(what)){
					var cur = obj[handler][what];
					for(var i=0;i<cur.length;i++){
						cur[i].sid = pid;
						this.mediaPool[handler][what].push(cur[i]);
					}
				}
			}
		}
	}
	if(!player.ship.docked) this.checkTrack();
	return(true);
};
// Unregister events
this.removeMedia = function(who)
{
	if(!who) return(false);
	var pid;
	for(var i=0;i<this.mediaPool.allListed.length;i++){
		if(who===this.mediaPool.allListed[i][0]){
			pid = i;
			this.mediaPool.allListed = this.helper.arrRemoveByValue(this.mediaPool.allListed,this.mediaPool.allListed[pid]);
			break;
		}
	}
	if(typeof(pid)==="undefined") return(false);
	for(var handler in this.mediaPool){
		if(handler==="allListed") continue;
		for(var what in this.mediaPool[handler]){
			for(var i=0;i<this.mediaPool[handler][what].length;i++){
				if(this.mediaPool[handler][what][i].sid===pid){
					this.mediaPool[handler][what] = this.helper.arrRemoveByValue(this.mediaPool[handler][what],this.mediaPool[handler][what][i]);
					if(i>-1) i--;
				} else if(this.mediaPool[handler][what][i].sid>pid) this.mediaPool[handler][what][i].sid--;
			}
		}
	}
	return(true);
};
// Change status flag
this.changeStatus = function(who,status)
{
	for(var i=0;i<this.mediaPool.allListed.length;i++){
		if(who===this.mediaPool.allListed[i][0]){
			this.mediaPool.allListed[i][1] = status;
			if(!player.ship.docked) this.checkTrack();
			return(true);
		}
	}
	return(false);
};
this.cclm_findActive = function(element){return(this.mediaPool.allListed[element.sid][1]);};
this.performMedia = function(handler,specifier,followup)
{
	var cur,found=false;
	// Handle ent + followup
	if(followup && this.mediaPool[handler].hasOwnProperty("ent")){
		cur = this.mediaPool[handler].ent.filter(this.cclm_findActive,this);
		if(cur.length) found = this.loopChecks(cur,followup);
		if(found && (handler==="aegis" || handler==="planet")) this.blockPlanet = clock.absoluteSeconds+10;
		return;
	}
	// Handle standard specifier
	if(!found){
		cur = this.mediaPool[handler][specifier].filter(this.cclm_findActive,this);
		if(cur.length) found = this.loopChecks(cur);
		if(found && handler==="scooped" && specifier==="fuel") this.blockFuel = clock.absoluteSeconds+10;
		if(!found){
			// Handle - any
			if(this.mediaPool[handler].hasOwnProperty("any")){
				cur = this.mediaPool[handler].any.filter(this.cclm_findActive,this);
				if(!cur.length) return;
				found = this.loopChecks(cur);
			}
		}
	}
	if(found && (handler==="aegis" || handler==="planet")) this.blockPlanet = clock.absoluteSeconds+10;
	this.blockAlert = clock.absoluteSeconds;
	return;
};
this.isClose = function(entity)
{
	return(entity.isShip && entity.isValid);
};
this.performTracker = function()
{
	if(!player.ship.isValid){
		this.trackerTimer.stop();
		return;
	}
	var ents = system.filteredEntities(this,this.isClose,player.ship,25600);
	var cur = this.mediaPool.track.byName.filter(this.cclm_findActive,this),disable = true;
	for(var i=0;i<cur.length;i++){
		var sub = cur[i];
		if(!this.mediaPool.allListed[sub.sid][1]) continue;
		disable = false;
		var ws = this.mediaPool.allListed[sub.sid][0];
		if(sub.hasOwnProperty("prop") && !worldScripts[ws][sub.prop]) continue;
		for(var e=0;e<ents.length;e++){
			if(sub.ent!==ents[e].name || sub.ent===this.currentTrack) continue;
			if(sub.dist<player.ship.position.distanceTo(ents[e].position)) continue;
			if(sub.fadeQ){
				this.mediaFade.sound = "[cabal_common_music_fade"+sub.fadeQ+"]";
				this.mediaFade.play();
			}
			var cl = 1, bp = 0, rp = 0, nq = 0;
			if(sub.bypassQ){
				bp = sub.bypassQ;
				cl = 0;
			}
			if(sub.leaveQ) cl = 0;
			if(sub.onlyRepQ) rp = 1;
			if(sub.forceQ) nq = 1;
			this.runMedia(sub.music,cl,bp,rp,nq);
			this.currentTrack = sub.ent;
			return(true);
		}
	}
	// If all OXPs are off stop - re-enabling via changeStatus
	if(disable){
		this.trackerTimer.stop();
		delete this.trackerTimer;
	}
	return(false);
};
this.loopChecks = function(cur,followup)
{
	for(var i=0;i<cur.length;i++){
		var sub = cur[i];
		if(!this.mediaPool.allListed[sub.sid][1]) continue;
		var ws = this.mediaPool.allListed[sub.sid][0];
		if(sub.hasOwnProperty("prop") && !worldScripts[ws][sub.prop]) continue;
		if(followup && followup!==sub.ent) continue;
		if(sub.fadeQ){
			this.mediaFade.sound = "[cabal_common_music_fade"+sub.fadeQ+"]";
			this.mediaFade.play();
		}
		var cl = 1, bp = 0, rp = 0, nq = 0;
		if(sub.bypassQ){
			bp = sub.bypassQ;
			cl = 0;
		}
		if(sub.leaveQ) cl = 0;
		if(sub.onlyRepQ) rp = 1;
		if(sub.forceQ) nq = 1;
		this.runMedia(sub.music,cl,bp,rp,nq);
		return(true);
	}
	return(false)
};
this.runMedia = function(list,clear,bypass,replace,force)
{
	if(typeof(list)==="string"){
		Sound.playMusic(list);
		this.currentFile = list;
		if(clear) this.mediaQueue = null;
		else if(bypass){
			if(this.mediaTimer){
				if(this.mediaTimer.isRunning){
					this.mediaTimer.stop();
					this.mediaTimer.nextTime = clock.absoluteSeconds+bypass;
					this.mediaTimer.start();
				}
			}
		}
	} else {
		var flag=false;
		if((replace && !this.mediaQueue) || force) flag=true;
		this.mediaQueue = list;
		if(flag){
			if(force) this.doMediaTimer(1);
			else if(replace) this.doMediaTimer();
		}
	}
	return;
};
this.doMediaTimer = function(force)
{
	if(this.mediaTimer){
		if(this.mediaTimer.isRunning) this.mediaTimer.stop();
		delete this.mediaTimer;
	}
	if(!this.mediaQueue) return;
	var entry = 0;
	if(!force) entry = Math.floor(Math.random()*this.mediaQueue.length);
	var dura = this.mediaQueue[entry].duration;
	var rep = this.mediaQueue[entry].repeat;
	var delay = (dura+1)*(rep?rep:1);
	Sound.playMusic(this.mediaQueue[entry].file,rep);
	this.currentFile = this.mediaQueue[entry].file;
	this.mediaTimer = new Timer(this,this.doMediaTimer,delay);
	return;
};
this.shipWillDockWithStation = this.shipWillEnterWitchspace = this.shipDied = function()
{
	if(this.mediaTimer){
		if(this.mediaTimer.isRunning) this.mediaTimer.stop();
		delete this.mediaTimer;
	}
	if(this.trackerTimer){
		if(this.trackerTimer.isRunning) this.trackerTimer.stop();
		delete this.trackerTimer;
	}
	this.mediaQueue = null;
	this.currentTrack = null;
	this.currentFile = null;
};
this.shipWillLaunchFromStation = this.shipWillExitWitchspace = function()
{
	this.checkTrack();
};
this.shipTargetLost = function(target)
{
	if(!player.ship.isValid) return;
	if(target && target.name && target.name===this.currentTrack && target.position.distanceTo(player.ship)>25600) this.currentTrack = null;
};
this.checkTrack = function()
{
	if(!this.trackerTimer && this.mediaPool.track.byName.filter(this.cclm_findActive,this).length) this.trackerTimer = new Timer(this,this.performTracker,0,10);
	return;
};
this.alertConditionChanged = function(to)
{
	if(!player.ship.isValid || player.ship.status!=="STATUS_IN_FLIGHT") return;
	switch(to){
		case 3: this.performMedia("alert","red"); break;
		case 2: if(clock.absoluteSeconds>this.blockAlert) this.performMedia("alert","yellow"); break;
		case 1: if(clock.absoluteSeconds>this.blockAlert) this.performMedia("alert","green"); break;
	}
	this.blockAlert = clock.absoluteSeconds+10;
};
this.shipEnteredPlanetaryVicinity = function(planet)
{
	if(!player.ship.isValid || !planet || clock.absoluteSeconds<this.blockPlanet) return;
	if(planet.isMainPlanet) this.performMedia("planet","enterMain");
	else if(planet.isSun) this.performMedia("planet","enterSun");
	else this.performMedia("planet","ent",planet.radius);
};
this.shipEnteredStationAegis = function(station)
{
	if(!player.ship.isValid || !station || clock.absoluteSeconds<this.blockPlanet) return;
	this.performMedia("aegis","enter");
};
this.shipExitedPlanetaryVicinity = function(planet)
{
	if(!player.ship.isValid || !planet || clock.absoluteSeconds<this.blockPlanet) return;
	if(planet.isMainPlanet) this.performMedia("planet","exitMain");
	if(planet.isSun) this.performMedia("planet","exitSun");
};
this.shipExitedStationAegis = function(station)
{
	if(!player.ship.isValid || !station || clock.absoluteSeconds<this.blockPlanet) return;
	this.performMedia("aegis","exit");
};
this.shipExitedWitchspace = function()
{
	if(!player.ship.isValid) return;
	if(system.isInterstellarSpace) this.performMedia("exitWS","inter");
	else if(system.sun.hasGoneNova) this.performMedia("exitWS","goneNova");
	else if(system.sun.isGoingNova) this.performMedia("exitWS","doNova");
	else this.performMedia("exitWS","standard");
	this.checkTrack();
};
this.shipLaunchedFromStation = function(station)
{
	if(!player.ship.isValid || !station) return;
	if(station.isMainStation) this.performMedia("launch","main");
	else this.performMedia("launch","ent",station.name);
};
this.shipScoopedOther = function(whom)
{
	if(!player.ship.isValid || !whom || !whom.name) return;
	this.performMedia("scooped","ent",whom.name);
};
this.shipScoopedFuel = function()
{
	if(!player.ship.isValid || clock.absoluteSeconds<this.blockFuel) return;
	this.performMedia("scooped","fuel");
};
this.shipTargetDestroyed = function(target)
{
	if(!player.ship.isValid || !target || !target.name) return;
	this.performMedia("destroyed","ent",target.name);
};
