"use strict";
this.name = "Cabal_Common_Overlay";
this.author = "Svengali";
this.copyright = "(C)2010-2013, License:CC-by";
this.description = "Overlay handling";
this.version = "1.7";

this.startUp = function()
{
	delete this.startUp;
	this.ovList = [[0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0],[0]];
	this.ovListObj = [[0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0],[0]];
	this.ovInstrumentPos = [[8,8,9],[6,8,9],[4,8,9],[2,8,9],[0,8,9],[-2,8,9],[-4,8,9],[-6,8,9],[-8,8,9]];
	this.ovCharacterPos = [[8,5,9],[8,3,9],[8,1,9],[8,-1,9],[8,-3,9],[-8,5,9],[-8,3,9],[-8,1,9],[-8,-1,9],[-8,-3,9]];
	this.ovDeadSpotPos = [[0,0,1]];
	this.ovPredicate = null;
	if(oolite.gameSettings.shaderEffectsLevel==='SHADERS_OFF' || oolite.gameSettings.shaderEffectsLevel==='SHADERS_NOT_SUPPORTED') this.ovShadersOff = true;
};
this.shipWillLaunchFromStation = this.shipWillExitWitchspace = function()
{
	this.doAdd();
};
this.shipLaunchedFromStation = this.shipExitedWitchspace = function()
{
	this.cleanupTimer = new Timer(this,this.doCleanup,0,2);
};
this.shipWillDockWithStation = this.shipWillEnterWitchspace = function()
{
	if(this.cleanupTimer){this.cleanupTimer.stop(); delete this.cleanupTimer;}
	this.ovRemoveAll();
};
this.doCleanup = function()
{
	for(var c=0;c<3;c++){
		for(var cc=0;cc<this.ovList[c].length;cc++){
			if(!this.ovList[c][cc].isValid){
				this.ovList[c][cc] = 0;
				this.ovListObj[c][cc] = 0;
			}
		}
	}
	return;
};
this.doAdd = function()
{
	for(var o=0;o<3;o++){
		for(var i=0;i<this.ovListObj[o].length;i++) if(this.ovListObj[o][i]) this.ovAdd(this.ovListObj[o][i],1);
	}
	for(var c=0;c<3;c++){
		for(var cc=0;cc<this.ovList[c].length;cc++) if(!this.ovList[c][cc]) this.ovListObj[c][cc] = 0;
	}
	return;
};
// API
/* worldScripts.Cabal_Common_Overlay.ovAdd(obj,off)
	obj		Object. see below
	off		Boolean. If true overlay is added, but offscreen
	
	obj:
	cclov_id			String. Identifier.
	cclov_type			Number. 0=Notification, 1=Character, 2=Fullscreen
	cclov_autoremove	Boolean. Removes effect after cclov_blend seconds
	cclov_blend			Number. Duration for effect.
	cclov_fx			Entity. VisualEffect to be used instead.
	cclov_png			Texture. Must be specified if cclov_fx is not used.
	cclov_color			Array. RGB values in range 0...3 for character overlays.
	
	Returns:
		Visual Effect (when docked true) or false */
this.ovAdd = function(obj,off){
	if(!obj || typeof(obj.cclov_type)!=='number' || !obj.cclov_id) return(false);
	if(!obj.whom) obj.whom = player.ship;
	if(!obj.whom.isValid) return(false);
	if(!obj.cclov_type) obj.cclov_type = 0;
	var where = obj.whom.position,ind = -1,result,f,ents,lookup="ovList";
	// Check if exists already
	this.ovPredicate = obj.cclov_id;
	if(player.ship.docked){
		ents = this.ovFindDocked(0).concat(this.ovFindDocked(1));
		lookup = "ovListObj";
	} else ents = this.ovFind(0).concat(this.ovFind(1));
	if(ents.length) return(false);
	for(var i=0;i<this[lookup][obj.cclov_type].length;i++){
		if(this[lookup][obj.cclov_type][i]===0){
			ind = i;
			break;
		}
	}
	if(ind!==-1){
		if(player.ship.docked){
			this.ovListObj[obj.cclov_type][ind] = obj; // Store
			return(true);
		} else {
			if(obj.cclov_fx){
				f = system.addVisualEffect(obj.cclov_fx,where);
			} else {
				if(obj.cclov_color) f = system.addVisualEffect("ccl_overlay_color",where);
				else f = system.addVisualEffect("ccl_overlay",where);
			}
			if(f){
				if(obj.cclov_png) this.ovTexChange(f,obj.cclov_png);
				f.script.cclov_tar = obj.whom;
				if(this.ovShadersOff) f.script.cclov_noShade = true;
				this.ovList[obj.cclov_type][ind] = f;
				switch(obj.cclov_type){
					case 0: result = this.ovInstrumentPos[ind]; break;
					case 1: result = this.ovCharacterPos[ind]; break;
					case 2: result = this.ovDeadSpotPos[ind]; break;
				}
				f.shaderVector1 = result;
				if(obj.cclov_blend && obj.cclov_blend>0){
					if(obj.cclov_type===0) f.script.cclov_blendI = clock.absoluteSeconds+obj.cclov_blend;
					if(obj.cclov_type===1) f.script.cclov_blendC = clock.absoluteSeconds+obj.cclov_blend;
					if(obj.cclov_type===2) f.script.cclov_blendA = clock.absoluteSeconds+obj.cclov_blend;
				}
				f.script.cclov_id = obj.cclov_id;
				f.script.cclov_type = obj.cclov_type;
				this.ovListObj[obj.cclov_type][ind] = obj; // Store
				if(off && obj.cclov_blend!==-1){
					if(obj.cclov_type===0) f.shaderInt2 = 20;
					if(obj.cclov_type===1) f.shaderInt1 = 20;
				}
				if(obj.cclov_autoremove) f.script.cclov_autoremove = true;
				if(obj.cclov_type===1){
					if(obj.cclov_color) f.shaderVector2 = obj.cclov_color;
				}
				return(f);
			}
		}
	}
	return(false);
};
this.ovTexChange = function(what,cclov_png){
	var mat = what.getMaterials();
	var k = Object.keys(mat);
	if(typeof(mat[k[0]].textures[0])==='string') mat[k[0]].textures[0] = cclov_png;
	else mat[k[0]].textures[0].name = cclov_png;
	mat[k[0]].emission_map = cclov_png;
	mat[k[0]].ambient_color = [0,0,0,0];
	mat[k[0]].diffuse_color = [0,0,0,0];
	mat[k[0]].shininess = 0;
	what.setMaterials(mat);
	return(true);
};
this.ovSearch = function(element){
	return(element.isVisualEffect && element.script.cclov_id===this.ovPredicate);
};
this.ovFind = function(cclov_type,who){
	if(who) this.ovPredicate = who;
	return(this.ovList[cclov_type].filter(this.ovSearch,this));
};
this.ovFindDocked = function(cclov_type,who){
	if(who) this.ovPredicate = who;
	return(this.ovListObj[cclov_type].filter(this.ovSearch,this));
};
/* worldScripts.Cabal_Common_Overlay.ovSpeak(who,cclov_blend,message,whom,autoremove)
	who				String. Identifier.
	cclov_blend		Number. Duration for effect.
	message			String.
	whom			Entity.
	autoremove		Boolean. Removes effect after cclov_blend seconds. */
this.ovSpeak = function(who,cclov_blend,message,whom,autoremove){
	if(!who || !cclov_blend || !player.ship.isValid || player.ship.docked) return(false);
	this.ovPredicate = who;
	var ents = this.ovFind(0).concat(this.ovFind(1));
	if(!ents.length) return(false);
	var sc = ents[0].script;
	ents[0].shaderFloat2 = cclov_blend;
	if(message){
		if(whom){
			if(whom.isValid && whom.isShip) whom.commsMessage(message);
		} else {
			if(sc.cclov_type===1) player.commsMessage(who+": "+message,cclov_blend);
			else player.consoleMessage(who+": "+message,cclov_blend);
		}
		var snd = new SoundSource();
		snd.sound = "[cabal_common_commbeep]";
		snd.play();
	}
	if(cclov_blend){
		if(sc.cclov_type===0 && sc.cclov_blendI!==-1) sc.cclov_blendI = clock.absoluteSeconds+cclov_blend;
		if(sc.cclov_type===1 && sc.cclov_blendC!==-1) sc.cclov_blendC = clock.absoluteSeconds+cclov_blend;
	}
	if(sc.valueUpdate) sc.valueUpdate();
	if(autoremove) sc.cclov_autoremove = true;
	return(true);
};
this.ovLog = function(){
	for(var o=0;o<3;o++){
		for(var i=0;i<this.ovList[o].length;i++) if(this.ovList[o][i]) log("CCL_FX","List: cclov_type:"+o+" index:"+i+" : "+this.ovList[o][i].script.cclov_id);
		for(var i=0;i<this.ovListObj[o].length;i++) if(this.ovListObj[o][i]) for(var prop in this.ovListObj[o][i]) log("CCL_FX",prop+" : "+this.ovListObj[o][i][prop]);
	}
	return;
};
/* worldScripts.Cabal_Common_Overlay.ovRemove(who)
	who				String. Identifier. */
this.ovRemove = function(who){
	if(!player.ship.isValid) return(false);
	var ind = -1, li = 0,lookup = "ovList";
	if(player.ship.docked){
		lookup = "ovListObj";
		for(var i=0;i<this[lookup][0].length;i++) if(this[lookup][0][i] && this[lookup][0][i].cclov_id===who){
			ind = i; li = 0; break;
		}
		if(ind===-1){
			for(var i=0;i<this[lookup][1].length;i++) if(this[lookup][1][i] && this[lookup][1][i].cclov_id===who){
				ind = i; li = 1; break;
			}
		}
	} else {
		for(var i=0;i<this[lookup][0].length;i++) if(this[lookup][0][i] && this[lookup][0][i].script.cclov_id===who){
			ind = i; li = 0; break;
		}
		if(ind===-1){
			for(var i=0;i<this[lookup][1].length;i++) if(this[lookup][1][i] && this[lookup][1][i].script.cclov_id===who){
				ind = i; li = 1; break;
			}
		}
	}
	if(ind===-1) return(false);
	if(!player.ship.docked){
		this.ovList[li][ind].remove();
		this.ovList[li][ind] = 0;
	}
	this.ovListObj[li][ind] = 0;
	return(true);
};
this.ovRemoveAll = function(){
	var ar = 0;
	for(var o=0;o<3;o++){
		for(var i=0;i<this.ovList[o].length;i++){
			ar = 0;
			if(this.ovList[o][i]){
				if(!this.ovList[o][i].isValid){
					this.ovListObj[o][i] = 0;
					this.ovList[o][i] = 0;
				} else {
					if(this.ovList[o][i].script.cclov_autoremove) ar = 1;
					this.ovList[o][i].remove();
					this.ovList[o][i] = 0;
					if(ar) this.ovListObj[o][i] = 0;
				}
			}
		}
	}
	return(true);
};
