"use strict";
this.name = "Cabal_Common_SpecialMarkets";
this.author = "Svengali";
this.copyright = "(C)2010-2013, License:CC-by";
this.description = "Additional Market for special goods";
this.version = "1.7";

this.registerLocation = function(obj)
{
	if(this.startUp || !obj || !Object.isExtensible(obj)) return(0);
	var req = ["item","galaxy","buyID","sellID","cb","cbb","priceclass","refresh","desc","stationID"];
	var typ = ["string","object","object","object","string","string","number","number","string","object"];
	var ctyp = ["gemStones","gold","platinum","alienItems","alloys","computers","firearms","food","furs","liquorWines","luxuries","machinery","minerals","narcotics","radioactives","slaves","textiles"];
	for(var i=0;i<req.length;i++) if(!obj.hasOwnProperty(req[i]) || typeof(obj[req[i]])!=typ[i]) return(0);
	for(var id=0;id<obj.buyID.length;id++) if(obj.sellID.indexOf(obj.buyID[id])!==-1) return(0);
	var item,galaxy,buyID,sellID,stationID,cb,cbb,priceclass,refresh,desc,block,contract,contractUnit,contractDesc,offset,avail,times,decrease,blackFriday,legal,model,oneShot,blend;
	item = obj.item.substr(0,40);
	galaxy = obj.galaxy;
	buyID = obj.buyID;
	sellID = obj.sellID;
	stationID = obj.stationID;
	cb = obj.cb;
	cbb = obj.cbb;
	desc = obj.desc;
	priceclass = this.helper.clamp(obj.priceclass,100,5);
	refresh = this.helper.clamp(obj.refresh,1,0.06);
	if(!obj.hasOwnProperty("block") || typeof(obj.block)!=="boolean") block=false;
	else block = true;
	if(block || !obj.hasOwnProperty("contract") || typeof(obj.contract)!=="string") contract=false;
	else contract=true;
	if(contract){
		var c = ctyp.indexOf(obj.contract);
		if(c===-1) contract=false;
		else {
			if(!c) contractUnit = "g";
			else if(c===1 || c===2) contractUnit = "kg";
			else contractUnit = "t";
			contractDesc = displayNameForCommodity(ctyp[c]);
			stationID=[["main"],["main"]];
		}
	}
	if(!obj.hasOwnProperty("offset") || typeof(obj.offset)!=="number") offset=1.3;
	else offset = this.helper.clamp(obj.offset,5,1.3);
	if(!obj.hasOwnProperty("avail") || typeof(obj.avail)!=="number") avail=0;
	else avail = this.helper.clamp(obj.avail,25,0);
	if(!obj.hasOwnProperty("times") || typeof(obj.times)!=="number") times=clock.days;
	else times = this.helper.clamp(obj.times,clock.days,clock.days-900);
	if(!obj.hasOwnProperty("decrease") || typeof(obj.decrease)!=="number") decrease=0.1;
	else decrease = this.helper.clamp(obj.decrease,0.5,0.1);
	if(!obj.hasOwnProperty("blackFriday") || typeof(obj.blackFriday)!=="number") blackFriday=0;
	else blackFriday = this.helper.clamp(obj.blackFriday,0.2,0);
	if(!obj.hasOwnProperty("legal") || typeof(obj.legal)!=="boolean") legal=true;
	else legal=false;
	if(!obj.hasOwnProperty("model") || typeof(obj.model)!=="string") model="cargopod";
	else model = obj.model;
	if(!obj.hasOwnProperty("oneShot") || typeof(obj.oneShot)!=="boolean") oneShot=null;
	else oneShot = obj.oneShot;
	for(var goc=0;goc<galaxy.length;goc++){
		for(var loc=0;loc<buyID.length;loc++){
			if(this.hold){
				for(var o=0;o<8;o++){
					for(var i=0;i<this.hold[o].length;i++){
						if(item===this.hold[o][i].item && buyID[loc]===this.hold[o][i].buyID){
							times = this.hold[o][i].times;
							if(this.hold[o][i].hasOwnProperty("blend")) blend = this.hold[o][i].blend;
							if(this.hold[o][i].hasOwnProperty("hold") && !legal){
								this.inspection++;
								this.rockOn.push(item);
							}
							break;
						}
					}
				}
			}
			var place = {item:item,galaxy:galaxy[goc],buyID:buyID[loc],sellID:sellID,stationID:stationID,cb:cb,cbb:cbb,priceclass:priceclass,refresh:refresh,
				desc:desc,block:block,contract:contract,contractUnit:contractUnit,contractDesc:contractDesc,offset:offset,avail:avail,times:times,
				decrease:decrease,blackFriday:blackFriday,legal:legal,model:model,oneShot:oneShot,blend:blend};
			this.marketLocations[galaxy[goc]].push(place);
		}
	}
	return(1);
};
// Removes item from lists
this.removeTradeItem = function(item,immediate)
{
	if(!immediate && this.delayRemove && player.ship.docked) this.delayRemove.push(item);
	else {
		for(var o=0;o<8;o++){
			for(var i=0;i<this.marketLocations[o].length;i++){
				if(item===this.marketLocations[o][i].item){
					this.marketLocations[o] = this.helper.arrRemoveByValue(this.marketLocations[o],this.marketLocations[o][i]);
					--i;
				}
			}
		}
	}
	return;
};
// Check players hold and return amount
this.checkPSHold = function(item)
{
	if(this.psHold.length){
		for(var i=0;i<this.psHold.length;i++){
			if(this.psHold[i].item===item) return(this.psHold[i].store);
		}
	}
	return(0);
};
this.cleanHold = function()
{
	if(this.psHold.length){
		for(var i=0;i<this.psHold.length;i++){
			if(!this.psHold[i].stored){
				this.psHold = this.helper.arrRemoveByValue(this.psHold,this.psHold[i]);
				--i;
			}
		}
	}
	return;
};
this.startUp = function()
{
	delete this.startUp;
	this.helper = new worldScripts.Cabal_Common_Functions.Cabal_Common();
	this.marketLocations = [[],[],[],[],[],[],[],[]];
	this.rockOn = [];
	this.psHold = [];
	this.holdPage = 0;
	this.prep(1);
	this.mso = false;
	this.inspection = 0;
	if(missionVariables.ccl_markets){
		this.hold = JSON.parse(missionVariables.ccl_markets);
		for(var o=0;o<8;o++){
			for(var i=0;i<this.hold[o].length;i++){
				if(this.hold[o][i].hasOwnProperty("hold")) this.psHold.push({item:this.hold[o][i].item,stored:this.hold[o][i].hold});
			}
		}
		missionVariables.ccl_markets = null;
	}
};
this.playerWillSaveGame = function()
{
	this.shipWillLaunchFromStation();
	var data = [[],[],[],[],[],[],[],[]],temp,check,ind;
	for(var o=0;o<8;o++){
		for(var i=0;i<this.marketLocations[o].length;i++){
			this.curItem = this.marketLocations[o][i];
			temp = {item:this.curItem.item,buyID:this.curItem.buyID,times:this.curItem.times};
			check = this.psHold.filter(this.ccls_findPSHold,this);
			if(!check.length) continue;
			ind = this.psHold.indexOf(check[0]);
			if(ind!==-1) temp.hold = check[0].stored;
			if(this.curItem.hasOwnProperty("blend")) temp.blend = this.curItem.blend;
			data[o].push(temp);
		}
	}
	missionVariables.ccl_markets = JSON.stringify(data);
	this.saved = true;
};
this.guiScreenChanged = function()
{
	if(!player.ship.docked) return;
	if(this.saved){
		missionVariables.ccl_markets = null;
		delete this.saved;
	}
};
this.shipWillExitWitchspace = function()
{
	this.prep(1);
};
this.guiScreenWillChange = function(to)
{
	if(to!=="GUI_SCREEN_EQUIP_SHIP") return;
	var buys = this.marketLocations[galaxyNumber].filter(this.ccls_findBuy,this);
	var sells = this.marketLocations[galaxyNumber].filter(this.ccls_findSell,this);
	var temp;
	sells = this.helper.arrSortByProperty(sells,"times");
	for(var w=0;w<sells.length;w++){
		if(temp && temp===sells[w].item){
			sells = this.helper.arrRemoveByValue(sells,sells[w]);
			--w;
		} else temp = sells[w].item;
	}
	this.trades = buys.concat(sells);
	if(this.trades.length){
		this.prep();
		EquipmentInfo.infoForKey("EQ_CABAL_COMMON_SPECIALMARKETS").effectiveTechLevel = 1;
	} else missionVariables.TL_FOR_EQ_CABAL_COMMON_SPECIALMARKETS = null;
};
this.prep = function(n)
{
	var temp = 0;
	if(!n) temp = this.store.rnd
	this.store = {diffTime:0,avail:0,totUnits:0,totBuy:0,totSell:0};
	this.snd = new SoundSource();
	if(n) this.store.rnd=this.helper.clamp(Math.random(),0.81,0.6);
	else this.store.rnd = temp;
	return;
};
this.ccls_findBuy = function(element){return(element.buyID===system.ID && ((player.ship.dockedStation.isMainStation && element.stationID[0].indexOf("main")!==-1) || (!player.ship.dockedStation.isMainStation && element.stationID[0].indexOf(player.ship.dockedStation.name)!==-1)));};
this.ccls_findSell = function(element){return(!element.contract && element.sellID.indexOf(system.ID)!==-1 && ((player.ship.dockedStation.isMainStation && element.stationID[1].indexOf("main")!==-1) || (!player.ship.dockedStation.isMainStation && element.stationID[1].indexOf(player.ship.dockedStation.name)!==-1)));};
this.ccls_findPSHold = function(element){return(element.item==this.curItem.item);};
this.shipWillLaunchFromStation = function()
{
	if(this.delayRemove){
		for(var i=0;i<this.delayRemove.length;i++) this.removeTradeItem(this.delayRemove[i],1);
		delete this.delayRemove;
	}
	missionVariables.TL_FOR_EQ_CABAL_COMMON_SPECIALMARKETS = null;
	delete this.curItem;
	delete this.curIndex;
	delete this.curPSHold;
	delete this.scr;
	delete this.snd;
	delete this.buy;
	this.mso = false;
	this.cleanHold();
};
this.shipWillEnterWitchspace = function()
{
	delete this.store;
};
this.playerBoughtEquipment = function(equipmentKey)
{
	if(equipmentKey==="EQ_CABAL_COMMON_SPECIALMARKETS"){
		player.ship.removeEquipment("EQ_CABAL_COMMON_SPECIALMARKETS");
		if(!this.delayRemove) this.delayRemove = [];
		this.cycleScreens();
	}
	return;
};
this.cycleScreens = function(){worldScripts.Cabal_Common_SpecialMarkets.cycler(); return;};
this.cycler = function()
{
	if(typeof(this.scr)==="undefined") this.scr=0;
	var chc = 0,txt = "",temp,l,blendOut=false;
	this.curItem = this.trades[this.scr];
	if(this.curItem.hasOwnProperty("blend") && clock.days<this.curItem.blend) blendOut=true;
	if(this.trades.length>1) chc += 4;
	if(this.curItem.buyID===system.ID) chc += 1;
	if(this.curItem.sellID.indexOf(system.ID)!==-1) chc += 2;
	if(this.curItem.model) this.showScreen("CABAL_COMMON_SPECIALMARKET_"+chc,this.curItem.model);
	else this.showScreen("CABAL_COMMON_SPECIALMARKET_"+chc,null);
	txt += this.curItem.item+(this.curItem.contract?" ("+this.curItem.contractDesc+")":"")+"\n-----------------------------------------------------\n";
	if(this.curItem.contract){
		this.store.tarSys = this.curItem.sellID[Math.floor(Math.random()*this.curItem.sellID.length)];
		this.store.tarSysName = System.systemNameForID(this.store.tarSys);
	}
	this.store.diffTime = this.helper.clamp(clock.days-this.curItem.times,1000,0);
	var dec = Math.log((1+this.curItem.decrease*this.store.diffTime)+(this.curItem.avail?Math.log(this.curItem.avail):0));
	var prod = this.curItem.refresh*this.store.diffTime;
	var prodTot = prod/(dec>1?1/dec:1);
	var us = (this.store.diffTime?(this.curItem.avail+(prod?prod:0.1)/(prodTot?prodTot:1)*(this.store.diffTime-dec)/(dec>1?dec:1))/(this.curItem.offset>1?this.curItem.offset:1.3)/Math.log(this.curItem.priceclass*0.3)*this.curItem.refresh:0);
	this.store.totUnits = Math.floor(us);
	if((chc&1) && blendOut) this.store.totUnits = 0;
	var pricernd = Math.sqrt(this.curItem.priceclass*this.store.rnd);
	this.store.totBuy = (((Math.random()>0,5?this.curItem.priceclass-pricernd:this.curItem.priceclass+pricernd)/(Math.log(us+3)*this.store.rnd)/(dec>1?dec:1))/this.curItem.decrease*(this.curItem.refresh?1/this.curItem.refresh:1))/Math.sqrt(this.curItem.offset);
	this.store.totBuy = parseFloat(this.store.totBuy.toFixed(1));
	this.store.totSell = this.store.totBuy*(this.curItem.offset-(1/(1/this.curItem.decrease)*this.store.rnd));
	this.store.totSell = parseFloat(this.store.totSell.toFixed(1));
	if(chc&1){
		temp=this.store.totUnits+" "+(this.curItem.block?"t":(this.curItem.contract?this.curItem.contractUnit:"g"))+"\n";
		l=defaultFont.measureString(temp);
		txt += this.helper.strToWidth("Units:",14-l," ")+temp;
		temp=global.formatCredits(this.store.totBuy,1,1)+"\n";
		l=defaultFont.measureString(temp);
		txt += this.helper.strToWidth("Buy:",14-l," ")+temp;
		temp=global.formatCredits(0,1,1)+"\n";
		l=defaultFont.measureString(temp);
		txt += this.helper.strToWidth("Sell:",14-l," ")+temp;
	} else {
		temp=this.store.totUnits+" "+(this.curItem.block?"t":(this.curItem.contract?this.curItem.contractUnit:"g"))+"\n";
		l=defaultFont.measureString(temp);
		txt += this.helper.strToWidth("Units:",14-l," ")+temp;
		temp=global.formatCredits(0,1,1)+"\n";
		l=defaultFont.measureString(temp);
		txt += this.helper.strToWidth("Buy:",14-l," ")+temp;
		temp=global.formatCredits(this.store.totSell,1,1)+"\n";
		l=defaultFont.measureString(temp);
		txt += this.helper.strToWidth("Sell:",14-l," ")+temp;
	}
	this.curPSHold = this.psHold.filter(this.ccls_findPSHold,this);
	this.curIndex = this.psHold.indexOf(this.curPSHold[0]);
	if(this.curPSHold.length) temp=this.curPSHold[0].stored+" "+(this.curItem.block?"t":(this.curItem.contract?this.curItem.contractUnit:"g"))+" / ("+player.ship.cargoSpaceAvailable+")\n";
	else temp="0 "+(this.curItem.block?"t":(this.curItem.contract?this.curItem.contractUnit:"g"))+" / ("+player.ship.cargoSpaceAvailable+")\n";
	if((chc&1) && player.ship.specialCargo) temp="- SEALED -\n";
	l=defaultFont.measureString(temp);
	txt += this.helper.strToWidth("Cargohold:",14-l," ")+temp;
	txt += "-----------------------------------------------------\n";
	if((chc&1)){
		txt += "Cost for all available:\f("+global.formatCredits(this.store.totUnits*this.store.totBuy,1,1)+")\n";
		txt += "Estimated TradeIn:\f\f("+global.formatCredits(this.store.totUnits*this.store.totSell,1,1)+")\n";
	} else {
		txt += "\n";
		if(this.curPSHold.length) txt += "Estimated TradeIn:\f\f("+global.formatCredits(this.curPSHold[0].stored*this.store.totSell,1,1)+")\n";
		else txt += "Estimated TradeIn:\f\f("+global.formatCredits(0,1,1)+")\n";
	}
	if(this.curItem.contract){
		var t = System.infoForSystem(galaxyNumber,system.ID).distanceToSystem(System.infoForSystem(galaxyNumber,this.store.tarSys));
		txt +=this.helper.strToWidth("Credits available:\f\f  ("+global.formatCredits(player.credits,1,1)+")",20," ");
		if(this.store.tarSys!==system.ID) txt += this.store.tarSysName+", "+t.toFixed(2)+"LY, "+this.helper.mapCoordsDirection(this.store.tarSys,system.ID)+"\n";
		else txt += "\n";
	} else txt += "Credits available:\f\f  ("+global.formatCredits(player.credits,1,1)+")\n";
	txt += "\nDescription:\n"+this.curItem.desc.substr(0,350);
	mission.addMessageText(txt);
	delete this.buy;
	this.mso = false;
	return;
};
this.showScreen = function(chc,model)
{
	var spin = null,ov="cabal_common_specialmarkets_ov.png";
	if(typeof(model)!=="undefined") spin = true;
	if(this.curItem.block){
		if(this.curItem.buyID===system.ID) ov="cabal_common_specialmarkets_ovSeal.png";
		else ov="cabal_common_specialmarkets_ovUnseal.png";
	} else if(this.curItem.contract) ov="cabal_common_specialmarkets_ovContract.png";
	mission.runScreen({title:system.name+" Special Market",background:"cabal_common_specialmarkets.png",overlay:ov,choicesKey:chc,music:"cabal_common_specialmarkets.ogg",model:model,spinModel:spin},this.choiceEval);
	if(model) this.helper.entScreenCornerPos(0.8,0.9,1.1,3.2);
	return;
};
this.choiceEval = function(choice){worldScripts.Cabal_Common_SpecialMarkets.choiceEvaluation(choice); return;};
this.choiceEvaluation = function(choice)
{
	if(!choice) return;
	switch(choice){
		case "CABAL_COMMON_SPECIALMARKETA": this.scr++; if(this.scr>=this.trades.length) this.scr=0; this.cycleScreens(); break;
		case "CABAL_COMMON_SPECIALMARKETBA":
			if(!player.ship.cargoSpaceAvailable || player.ship.cargoSpaceAvailable<this.store.totUnits){
				this.snd.sound = "ccl_markets_fail.ogg";
			} else if(player.credits>=this.store.totUnits*this.store.totBuy){
				if(!this.store.totUnits){
					this.snd.sound = "ccl_markets_nounits.ogg";
				} else {
					if(!this.curItem.contract){
						if(this.curItem.block && player.ship.cargoSpaceAvailable<player.ship.cargoSpaceCapacity){
							this.snd.sound = "ccl_markets_fail.ogg";
							this.snd.play();
							this.cycleScreens();
							return;
						}
						if(this.curIndex===-1) this.psHold.push({item:this.curItem.item,stored:this.store.totUnits});
						else this.psHold[this.curIndex].stored += this.store.totUnits;
					}
					player.credits -= this.store.totUnits*this.store.totBuy;
					this.trades[this.scr].blend = clock.days+Math.ceil(Math.log(this.curItem.priceclass));
					if(!this.curItem.legal){
						this.inspection++;
						this.rockOn.push(this.curItem.item);
					}
					if(this.curItem.block) player.ship.useSpecialCargo(this.curItem.item);
					else if(this.curItem.contract){
						var t = System.infoForSystem(galaxyNumber,system.ID).distanceToSystem(System.infoForSystem(galaxyNumber,this.store.tarSys))*1.3;
						player.ship.awardContract(this.store.totUnits,this.curItem.contractDesc,system.ID,this.store.tarSys,clock.seconds+t*24*3600,this.store.totUnits*this.store.totSell)
					}
					this.snd.sound = "ccl_markets_bought.ogg";
				}
			} else this.snd.sound = "ccl_markets_creditsfail.ogg";
			this.snd.play();
			this.cycleScreens();
			break;
		case "CABAL_COMMON_SPECIALMARKETBN":
			if(!player.ship.cargoSpaceAvailable || player.ship.cargoSpaceAvailable<this.store.totUnits){
				this.snd.sound = "ccl_markets_fail.ogg";
				this.snd.play();
				this.cycleScreens();
			} else if(!this.store.totUnits){
				this.snd.sound = "ccl_markets_nounits.ogg";
				this.snd.play();
				this.cycleScreens();
			} else {
				worldScripts.Cabal_Common_Keyboard.start(this.name,1,2);
				this.mso = true;
				this.buy = true;
			}
			break;
		case "CABAL_COMMON_SPECIALMARKETSA":
			if(this.curIndex!==-1){
				if(this.curPSHold.length && this.psHold[this.curIndex].stored){
					if(worldScripts[this.trades[this.scr].cb] && worldScripts[this.trades[this.scr].cb][this.trades[this.scr].cbb]){
						if(this.curItem.buyID===system.ID) this.trades[this.scr].avail += this.psHold[this.curIndex].stored;
						player.credits += this.psHold[this.curIndex].stored*this.store.totSell;
						var cr = this.psHold[this.curIndex].stored;
						this.psHold[this.curIndex].stored = 0;
						if(this.curItem.block && player.ship.specialCargo===this.curItem.item) player.ship.removeAllCargo();
						var check = worldScripts[this.trades[this.scr].cb][this.trades[this.scr].cbb](this.psHold[this.curIndex].item,cr);
						if(!this.curItem.legal){
							this.inspection--;
							if(this.inspection<0) this.inspection=0;
							this.rockOn = this.helper.arrRemoveByValue(this.rockOn,this.curItem.item);
						}
						if(this.curItem.oneShot) this.removeTradeItem(this.curItem.item);
						if(check) this.snd.sound = "ccl_markets_complete.ogg";
						else {
							this.snd.sound = "ccl_markets_sold.ogg";
							this.snd.play();
							this.mso = true;
							return; // OXPs displays own screen
						}
					} else this.snd.sound = "ccl_markets_fail.ogg";
				} else this.snd.sound = "ccl_markets_nounits.ogg";
			} else this.snd.sound = "ccl_markets_nounits.ogg";
			this.snd.play();
			this.cycleScreens();
			break;
		case "CABAL_COMMON_SPECIALMARKETSN":
			if(this.curPSHold.length || this.curIndex===-1 || !this.psHold[this.curIndex].stored){
				this.snd.sound = "ccl_markets_nounits.ogg";
				this.snd.play();
				this.cycleScreens();
			} else {
				worldScripts.Cabal_Common_Keyboard.start(this.name,1,2);
				this.mso = true;
				this.buy = false;
			}
			break;
		case "CABAL_COMMON_SPECIALMARKETP":
			this.holdPage++;
			if(this.holdPage*10>this.psHold.length-1) this.holdPage = 0;
			var a = this.holdPage*10,chc;
			if(a>this.psHold.length-1) a = 0;
			chc = "CABAL_COMMON_SPECIALMARKET_OVERVIEW_3";
			var b = this.helper.clamp(this.psHold.length,99,0);
			b = Math.min(b,a+10);
			mission.runScreen({title:"Loaded Cargo",background:"cabal_common_specialmarkets.png",overlay:"cabal_common_specialmarkets_ov.png",choicesKey:chc,music:"cabal_common_specialmarkets.ogg"},this.choiceEval);
			for(var c=a;c<b;c++) mission.addMessageText(this.helper.strToWidth(this.psHold[c].item,14)+" : "+this.psHold[c].stored);
			break;
		case "CABAL_COMMON_SPECIALMARKETX":
			this.cycleScreens();
			break;
		case "CABAL_COMMON_SPECIALMARKETY":
			if(!this.psHold.length){
				mission.runScreen({title:"Loaded Cargo",background:"cabal_common_specialmarkets.png",overlay:"cabal_common_specialmarkets_ov.png",choicesKey:"CABAL_COMMON_SPECIALMARKET_OVERVIEW_2",music:"cabal_common_specialmarkets.ogg"},this.choiceEval);
				mission.addMessageText("No special good in your hold.");
			} else {
				var a = this.holdPage*10,chc;
				if(this.psHold.length-1<10){
					a = 0;
					chc = "CABAL_COMMON_SPECIALMARKET_OVERVIEW_2";
				} else chc = "CABAL_COMMON_SPECIALMARKET_OVERVIEW_3";
				var b = this.helper.clamp(this.psHold.length,99,0);
				b = Math.min(b,a+10);
				mission.runScreen({title:"Loaded Cargo",background:"cabal_common_specialmarkets.png",overlay:"cabal_common_specialmarkets_ov.png",choicesKey:chc,music:"cabal_common_specialmarkets.ogg"},this.choiceEval);
				for(var c=a;c<b;c++) mission.addMessageText(this.helper.strToWidth(this.psHold[c].item,14)+" : "+this.psHold[c].stored);
			}
			break;
		case "CABAL_COMMON_SPECIALMARKETZ":
			this.shipWillLaunchFromStation();
			break;
		default: log("Choice not handled.");
	}
	return;
};
this.Cabal_Common_Keyboard_Output = function(input){worldScripts.Cabal_Common_SpecialMarkets.keyboardEval(input); return;};
this.keyboardEval = function(input)
{
	if(!input || input==="" || input==="0"){
		this.cycleScreens();
		return;
	}
	var cr = parseInt(input,null);
	if(this.buy){
		if(!player.ship.cargoSpaceAvailable || player.ship.cargoSpaceAvailable<this.store.totUnits){
			this.snd.sound = "ccl_markets_fail.ogg";
		} else if(player.credits>=cr*this.store.totBuy){
			if(!this.store.totUnits){
				this.snd.sound = "ccl_markets_nounits.ogg";
			} else {
				if(this.store.totUnits<cr) cr = this.store.totUnits;
				if(!this.curItem.contract){
					if(player.ship.cargoSpaceAvailable<player.ship.cargoSpaceCapacity){
						this.snd.sound = "ccl_markets_fail.ogg";
						this.snd.play();
						this.cycleScreens();
						return;
					}
					if(this.curIndex===-1) this.psHold.push({item:this.curItem.item,stored:cr});
					else this.psHold[this.curIndex].stored += cr;
				}
				player.credits -= cr*this.store.totBuy;
				this.trades[this.scr].blend = clock.days+Math.ceil(Math.log(this.curItem.priceclass)); // Only one trade? - TODO
				if(!this.curItem.legal){
					this.inspection++;
					if(this.rockOn.indexOf(this.curItem.item)===-1) this.rockOn.push(this.curItem.item);
				}
				if(this.curItem.block) player.ship.useSpecialCargo(this.curItem.item);
				else if(this.curItem.contract){
					var t = System.infoForSystem(galaxyNumber,system.ID).distanceToSystem(System.infoForSystem(galaxyNumber,this.store.tarSys))*1.3;
					player.ship.awardContract(cr,this.curItem.contractDesc,system.ID,this.store.tarSys,clock.seconds+t*24*3600,cr*this.store.totSell)
				}
				this.snd.sound = "ccl_markets_bought.ogg";
			}
		} else this.snd.sound = "ccl_markets_creditsfail.ogg";
		this.snd.play();
		this.cycleScreens();
	} else {
		if(this.psHold[this.curIndex].stored){
			if(this.psHold[this.curIndex].stored<cr) cr = this.psHold[this.curIndex].stored;
			if(worldScripts[this.trades[this.scr].cb] && worldScripts[this.trades[this.scr].cb][this.trades[this.scr].cbb]){
				if(this.curItem.buyID===system.ID) this.trades[this.scr].avail += cr;
				player.credits += cr*this.store.totSell;
				this.psHold[this.curIndex].stored -= cr;
				if(this.curItem.block && player.ship.specialCargo===this.curItem.item) player.ship.removeAllCargo();
				if(!this.psHold[this.curIndex].stored){
					this.inspection--;
					if(this.inspection<0) this.inspection=0;
					this.rockOn = this.helper.arrRemoveByValue(this.rockOn,this.psHold[this.curIndex].item);
				}
				var check = worldScripts[this.trades[this.scr].cb][this.trades[this.scr].cbb](this.psHold[this.curIndex].item,cr);
				if(!this.psHold[this.curIndex].stored && this.curItem.oneShot) this.removeTradeItem(this.curItem.item);
				if(check) this.snd.sound = "ccl_markets_complete.ogg";
				else {
					this.snd.sound = "ccl_markets_sold.ogg";
					this.snd.play();
					this.mso = true;
					return; // OXPs displays own screen
				}
			} else this.snd.sound = "ccl_markets_fail.ogg";
		} else this.snd.sound = "ccl_markets_nounits.ogg";
		this.snd.play();
		this.cycleScreens();
	}
	return;
};
this.missionScreenOpportunity = function()
{
	if(this.mso) this.cycleScreens();
};
this.shipEnteredStationAegis = function(station)
{
	if(station && this.inspection && player.ship.isValid){
		if(this.rockOn.length && Math.random()>0.9){
			if(worldScripts.vector_insp) worldScripts.vector_insp.startInspection(station,this.rockOn);
			else {
				var pen = Math.ceil(Math.sqrt(system.government+1)*this.rockOn.length);
				player.addMessageToArrivalReport("You're fined with "+pen+" Credits for trading in illegal goods without license.");
				player.credits -= pen;
			}
		}
	}
};
/*
this.specialCargo = function(what,amount)
{
	return(true);
};
*/
