"use strict";
this.name = "cabal_common_comm_eq";
this.author = "Svengali";
this.copyright = "(C)2010-2013, License:CC-by";
this.description = "Secure comms channels - EQ script.";
this.version = "1.7";

this.activated = function()
{
	if(!this.beep){
		this.beep = new SoundSource();
		this.beep.sound = "[cabal_common_commbeep]";
	}
	if(worldScripts.Cabal_Common_Comms.commChannelChanged){
		this.store = worldScripts.Cabal_Common_Comms.commChannels;
		worldScripts.Cabal_Common_Comms.commChannelChanged = false;
		if(this.control) delete this.control;
	}
	if(!this.store) return;
	if(!this.control || ((new Date()).getTime()-this.control.lastPress)>5000){
		this.control = {actions:this.store,mode:0,cycleA:0,cycleB:0,selected:0,lastPress:1};
		var current = this.control.actions[this.control.cycleA];
		player.consoleMessage(current.display,2);
	} else {
		if(((new Date()).getTime()-this.control.lastPress)<1200){
			var current;
			if(!this.control.mode){
				this.control.cycleA++;
				if(this.control.cycleA>this.control.actions.length-1) this.control.cycleA = 0;
				this.control.selected = this.control.cycleA;
				current = this.control.actions[this.control.cycleA];
			} else {
				this.control.cycleB++;
				if(this.control.cycleB>this.control.actions[this.control.cycleA].react.length-1) this.control.cycleB = 0;
				current = this.control.actions[this.control.cycleA].react[this.control.cycleB];
			}
			player.consoleMessage(current.display,2);
		} else {
			var current,shorter;
			if(!this.control.mode) current = this.control.actions[this.control.cycleA];
			else current = this.control.actions[this.control.cycleA].react[this.control.cycleB];
			switch(this.control.mode){
				case 0:
					if(current.display==="Discard"){
						this.beep.play();
						delete this.control;
						player.consoleMessage('Cleared.',2);
						return;
					} else {
						if(current.display==="Open channel"){
							if(player.ship.target) this.requestChannel();
							else player.consoleMessage('No target.',2);
							delete this.control;
							this.beep.play();
							return;
						} else {
							this.control.cycleB = 0;
							this.control.mode = 1;
							current = this.control.actions[this.control.cycleA].react[this.control.cycleB];
						}
					}
					player.consoleMessage(current.display,2);
					break;
				case 1:
					if(current.display==="Back"){
						this.control.cycleA = this.control.selected;
						this.control.cycleB = 0;
						this.control.mode = 0;
						current = this.control.actions[this.control.cycleA];
					} else {
						shorter = this.control.actions[this.control.cycleA];
						if(shorter.ent){
							if(shorter.who.isValid){
								if(shorter.noDist || shorter.who.position.distanceTo(player.ship.position)<25600){
									shorter.who.script[shorter.callback](this.control.cycleB);
								} else player.consoleMessage('Signal weak',2);
							}
						} else {
							if(worldScripts[shorter.who] && !worldScripts[shorter.who].deactivated){
								if(shorter.eID && shorter.eID.isValid){
									if(shorter.eID.position.distanceTo(player.ship.position)<25600){
										worldScripts[shorter.who][shorter.callback](this.control.cycleB,shorter.pID,shorter.react[this.control.cycleB]);
									} else player.consoleMessage('Signal weak',2);
								} else worldScripts[shorter.who][shorter.callback](this.control.cycleB,shorter.pID);
							}
						}
						delete this.control;
						this.beep.play();
						return;
					}
					player.consoleMessage(current.display,2);
					break;
			}
		}
	}
	this.control.lastPress = (new Date()).getTime();
	this.beep.play();
};
this.requestChannel = function()
{
	var pst = player.ship.target;
	if(!pst.isShip || pst.isCargo || pst.isWeapon || pst.isRock || pst.isDerelict || !pst.isPiloted){
		player.consoleMessage('Not possible.',2);
		return;
	}
	this.patchedIDs = worldScripts.Cabal_Common_Comms.patchedIDs;
	if(this.patchedIDs.indexOf(pst.entityPersonality)===-1){
		if(pst.scriptInfo && pst.scriptInfo.ccl_secureChannel){
			var channel = pst.scriptInfo.ccl_secureChannel;
			if(pst.script[channel]){
				if(worldScripts.Cabal_Common_Comms.addToComm(pst.script[channel])) player.consoleMessage('Channel created.',2);
				return;
			} else {
				if(pst.scriptInfo.ccl_secureChannelPrep){
					if(pst.script[pst.scriptInfo.ccl_secureChannelPrep]){
						pst.script[pst.scriptInfo.ccl_secureChannelPrep]();
						var channel = pst.scriptInfo.ccl_secureChannel;
						if(worldScripts.Cabal_Common_Comms.addToComm(pst.script[channel])) player.consoleMessage('Channel created.',2);
						return;
					} else player.consoleMessage('Not available.',2);
				} else player.consoleMessage('Not available.',2);
			}
		} else player.consoleMessage('Request denied.',2);
	} else player.consoleMessage('Already done.',2);
	return;
};
